
        .XCREF
        .NOLIST
        INCLUDE \masm32\include\masm32rt.inc
        .LIST

;###########################################################################

        .CODE

;***************************************************************************

_main   PROC

        call    Faster
        print   uhex$(eax), 13, 10

        call    Multipler
        print   uhex$(eax), 13, 10

        inkey
        exit

_main   ENDP

;***************************************************************************

Faster  PROC

        push    ebx

        mov     ebx, 3
        xor     eax, eax
        mov     ecx, 100000000
        mov     edx, ebx

Loop00: add     eax, ebx
        add     ebx, edx
        cmp     ebx, ecx
        jbe     Loop00


;We have already added the ones that are divisable by 3.
;We now want to add the ones that are divisable by 5.
;However, we do not want to add the ones that are divisable by 15,
;because they have already been added in the 3's loop.
;So, we start at 5, then do 10, then skip 15, and so on.

        mov     ebx, 5
        mov     edx, ebx

Loop01: add     eax, ebx
        add     ebx, edx
        cmp     ebx, ecx
        ja      Exit00

        add     eax, ebx
        add     ebx, edx
        add     ebx, edx
        cmp     ebx, ecx
        jbe     Loop01

Exit00: pop     ebx
        ret

Faster  ENDP

;***************************************************************************

Multipler PROC

        push    ebx
        push    esi
        push    edi
        push    ebp

        mov     ebx, 100000000
        mov     esi, 3
        mov     edi, 5
        xor     ebp, ebp

        ALIGN   16

n1:     mov     eax, ebx
        xor     edx, edx
        div     esi
        test    edx, edx
        jz      n2

        mov     eax, ebx
        xor     edx, edx
        div     edi
        test    edx, edx
        jnz     n3

n2:     add     ebp, ebx

n3:     sub     ebx, 1
        jnz     n1

        mov     eax, ebp
        pop     ebp
        pop     ebx
        pop     edi
        pop     esi
        ret

Multipler ENDP

;###########################################################################

        END     _main

